<?php

if ( ! class_exists( '_WP_Editors' ) ) {
	require ABSPATH . WPINC . '/class-wp-editor.php';
}

function panorama360_translation() {
	$strings = array(
		'buttonTitle' => __( 'Insert 360° panorama', 'panorama360' ),
		'submitButton' => __( 'Insert Shortcode', 'panorama360' ),
		'cancelButton' => __( 'Cancel', 'panorama360' ),
		'image' => __( 'Image', 'panorama360' ),
		'imageUpload' => __( 'Upload', 'panorama360' ),
		'imageRemove' => __( 'Remove', 'panorama360' ),
		'imageAlt' => __( 'Image Alt Attribute', 'panorama360' ),
		'imageWidth' => __( 'Image Width', 'panorama360' ),
		'imageHeight' => __( 'Image Height', 'panorama360' ),
		'imageType' => __( 'Panorama Type', 'panorama360' ),
		'imageTypeDescription' => __( 'Determine the type of rotation of the panorama image.', 'panorama360' ),
		'cssStyle' => __( 'Extra CSS Style', 'panorama360' ),
		'cssStyleDescription' => __( 'Add extra CSS style to the panorama container.', 'panorama360' ),
		'startPosition' => __( 'Start Position', 'panorama360' ),
		'startPositionDescription' => __( 'Initial horizontal position of the panoramic viewer.', 'panorama360' ),
		'title' => __( 'Title', 'panorama360' ),
		'titleLink' => __( 'Title Link', 'panorama360' ),
		'titleLinkTarget' => __( 'Title Link Target', 'panorama360' ),
		'titleLinkTargetSame' => __( 'Open in same tab/window', 'panorama360' ),
		'titleLinkTargetNew' => __( 'Open in new tab/window', 'panorama360' ),
		'mouseWheel' => __( 'Mouse Wheel', 'panorama360' ),
		'mouseWheelDescription' => __( 'Determine if the panorama can be controlled with the mouse wheel scroll.', 'panorama360' ),
		'mouseWheelMultiplier' => __( 'Mouse Wheel Multiplier', 'panorama360' ),
		'mouseWheelMultiplierDescription' => __( 'Determine the mouse wheel scrolling factor.', 'panorama360' ),
		'slidingControls' => __( 'Sliding Controls', 'panorama360' ),
		'slidingControlsDescription' => __( 'Determine if the sliding controls are visible at the bottom of the panoramic viewer.', 'panorama360' ),
		'slidingDirection' => __( 'Automatic Sliding', 'panorama360' ),
		'slidingDirectionNo' => __( 'No', 'panorama360' ),
		'slidingDirectionLeft' => __( 'Left side', 'panorama360' ),
		'slidingDirectionRight' => __( 'Right side', 'panorama360' ),
		'slidingInterval' => __( 'Sliding Interval', 'panorama360' ),
		'slidingIntervalDescription' => __( 'Sets the slide timer refresh interval (in miliseconds).', 'panorama360' ),
		'slidingFactor' => __( 'Sliding Factor', 'panorama360' ),
		'slidingFactorDescription' => __( 'Sets the slide movement factor, slows it down if lower (between 0.1 and 1).', 'panorama360' ),
		'blockContextMenu' => __( 'Block Context Menu', 'panorama360' ),
		'blockContextMenuDescription' => __( 'Determines if the context menu is blocked (right click on the panoramic viewer).', 'panorama360' ),
		'popupDescription' => __( 'For more details please consult the ', 'panorama360' ) . '<a href=\"http://docs.liviucerchez.com/panorama360/\" target=\"_blank\">' . __( 'complete documentation', 'panorama360' ),
	);
	$locale = _WP_Editors::$mce_locale;
	$translated = 'tinyMCE.addI18n("' . $locale . '.panorama360", ' . json_encode( $strings ) . ");\n";
	return $translated;
}

$strings = panorama360_translation();